﻿importPackage(Packages.org.ten60.netkernel.xml.representation);

importClass(Packages.com.ten60.netkernel.urii.IURRepresentation);
importClass(Packages.org.ten60.netkernel.xml.representation.IAspectXDA);

// get the current request
req = context.getThisRequest();

// the operand determines the CWU for the generated DPML script
//java.lang.System.err.println("DBG:sloot.accessor CWU["+context.getCWU()+"]["+req.getArgument("operand")+"]");
cwu = req.getArgument("operand");

// create the DPML script
subreq = context.createSubRequest();
subreq.setURI("active:xslt2");

//subreq.addArgument("operand",(IURRepresentation)(context.source(req.getArgument("operand"))));
operandURI = req.getArgument("operand");
if (operandURI != null) {
    operandValue = req.getArgumentValue(operandURI);
	if (operandValue != null) {
		subreq.addArgument("operand",operandValue);
	} else {
        subreq.addArgument("operand",operandURI);
	}
} else
    java.lang.System.err.println("ERR:sloot.accessor call without an operand");
subreq.addArgument("operator","ffcpl:/tools/accessor.xsl");

script = context.issueSubRequest(subreq);

//java.lang.System.err.println("DBG:created DPML script");

// dump the DPML script
//context.sinkAspect("ffcpl:/trace/accessor.idoc",script.getAspect(IAspectXDA));

/**/
subreq = context.createSubRequest();
subreq.setURI("active:serialize");
subreq.addArgument("operand",script);
//subreq.addArgument("target","ffcpl:/sloot-trace/accessor.idoc");

res = context.issueSubRequest(subreq);
context.sinkAspect("ffcpl:/sloot-trace/accessor.idoc",res.getAspect(IAspectXDA));
/**/

//java.lang.System.err.println("DBG:dumped DPML script");

// run the DPML script
subreq = context.createSubRequest();
subreq.setURI("active:dpml");
subreq.addArgument("operand",script);

op  = <dpml><inheritCWU>t</inheritCWU></dpml>;
xop = new XmlObjectAspect(op.getXmlObject());

subreq.addArgument("operator",xop);

subreq.setCWU(cwu);

for(iter = req.getArguments(); iter.hasNext(); ) {
	arg = iter.next();
	if (!(arg.equals("operand") || arg.equals("operator"))) {
		//java.lang.System.out.println("DBG:accessor.js:arg["+arg+"]");
		argURI = req.getArgument(arg);
		if (argURI != null) {
		//	java.lang.System.out.println("DBG:accessor.js:arg["+arg+"]["+argURI+"]");
			argValue = req.getArgumentValue(argURI);
		//	java.lang.System.out.println("DBG:accessor.js:arg["+arg+"]["+argURI+"]["+argValue+"]");
			if (argValue != null) {
		//		java.lang.System.out.println("DBG:accessor.js:arg["+arg+"]["+argValue+"] value");
				subreq.addArgument(arg,argValue);
			} else {
		//		java.lang.System.out.println("DBG:accessor.js:arg["+arg+"]["+argURI+"] URI");
                subreq.addArgument(arg,argURI);
			}
		}// else
		//	java.lang.System.out.println("DBG:accessor.js:arg["+arg+"] null");
	}
}

result = context.issueSubRequest(subreq);

//java.lang.System.err.println("DBG:ran DPML script");

// create response, and exit
response = context.createResponseFrom(result);
response.setCacheable();

//java.lang.System.err.println("DBG:returned response");
